
#include <pthread.h> 
#include "string_set.h"
#include <stdlib.h>
#include <string.h>

#define INITIAL_SET_SIZE 2

struct StringSet {
  int num_elts;
  int array_size;
  char ** array;
};

struct StringSet * new_string_set() {
  struct StringSet * ans = (struct StringSet*)malloc(sizeof(struct StringSet));
  ans->num_elts=0;
  ans->array_size = INITIAL_SET_SIZE;
  ans->array = (char**)malloc(INITIAL_SET_SIZE*sizeof(char*));
  return ans;
}

int use_string_set(struct StringSet * set) {
  return 1;
}

void finished_string_set(struct StringSet *set) {
  int i;
  for(i=0; i<set->num_elts; ++i)
    free(set->array[i]);
  free(set->array);
}

void destroy_string_set(struct StringSet *set) {
  free(set);
}

int string_set_member(struct StringSet *set, char* s) {
  int i;
  for(i=0; i<set->num_elts; ++i)
    if(!strcmp(set->array[i],s))
      return 1;
  return 0;
}

int string_set_add(struct StringSet *set, char* str) {
  if(string_set_member(set,str))
    return 0;
  if(set->num_elts==set->array_size) {
    set->array_size *= 2;
    char** new_arr = (char**)malloc(set->array_size*sizeof(char*));
    int i;
    for(i=0; i < set->num_elts; ++i)
      new_arr[i] = set->array[i];
    free(set->array);
    set->array = new_arr;
  }
  set->array[set->num_elts] = strdup(str);
  ++set->num_elts;
  return 0;
}

int string_set_foreach(struct StringSet *set, void (*f)(char*)) {
  int i;
  for(i=0; i<set->num_elts; ++i)
    (*f)(set->array[i]);
  return 0;
}
